; Simple GENSYM function
; By Nils M Holm, 2018
;
; Provided under the Creative Common Zero (CC0) license
; (https://creativecommons.org/publicdomain/zero/1.0/)
;
; From the book COMPILING LAMBDA CALCULUS, http://t3x.org/clc/

(define gensym
  (let ((n 0))
    (lambda (s)
      (set! n (+ 1 n))
      (string->symbol
        (string-append
          s
          (number->string n))))))
